using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;


namespace MuoviPallina
{

    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class UpdateAndFramePS : Microsoft.Xna.Framework.DrawableGameComponent
    {
        private SpriteBatch batch;
        private SpriteFont impactFont;
        
        public UpdateAndFramePS(Game game)
            : base(game)
        {

            // TODO: Construct any child components here
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here
            base.Initialize();
        }

        protected override void LoadContent()
        {
            impactFont = this.Game.Content.Load<SpriteFont>("impact");
            batch = new SpriteBatch(this.Game.GraphicsDevice);
            base.LoadContent();
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            DateTime now = DateTime.Now;
            updatePerSecond = (float)(1 / (now - lastUpdate).TotalSeconds);
            lastUpdate = now;
            base.Update(gameTime);
        }

        private DateTime lastUpdate = DateTime.Now;
        private DateTime lastDraw = DateTime.Now;
        private float updatePerSecond;
        private float updatePerSecondDraw = -1;
        private float drawPerSecondDraw = -1;
        private DateTime nextRefresh = DateTime.Now;
        
        public override void Draw(GameTime gameTime)
        {
            DateTime now = DateTime.Now;
            if (now > nextRefresh) {
                updatePerSecondDraw = updatePerSecond;
                drawPerSecondDraw = ((float) (1 / (now - lastDraw).TotalSeconds));
                nextRefresh = now.AddSeconds(1);
            }

            this.batch.Begin();
            this.batch.DrawString(impactFont, drawPerSecondDraw.ToString("#.##") + " draw per second\n" + 
                updatePerSecondDraw.ToString("#.##") + " update per second", new Vector2(0, 0), Color.Red);
            this.batch.End();
            lastDraw = DateTime.Now;
            base.Draw(gameTime);
        }
    }
}